let evalf_def = new_definition `!(x:real) (p:num). N x p = x`;;
let evalf_rest_def = new_recursive_definition bool_RECURSION
 `(... x p F = x - floor (&10 pow p * x) / &10 pow p) /\
  (... x p T = x - floor (&10 pow p * x + &1 / &2) / &10 pow p)`
;;

let evalf_thm = prove (`abs(... x p v) < &1 / &10 pow p`,
 let l0 = prove (`&0 <  &10 pow p`, SIMP_TAC[REAL_POW_LT; REAL_ARITH `&0 < &10`]) in
 let l1 = prove (`~(&0 = &10 pow p)`, SIMP_TAC[REAL_NOT_EQ; l0]) in
 let l2 = prove (`x = (&10 pow p * x) / &10 pow p`, SIMP_TAC[real_div; REAL_MUL_AC; REAL_MUL_LINV; l1; REAL_MUL_RID]) in
 let l3 = prove (`frac x = x - floor x`, SIMP_TAC[REAL_EQ_SUB_LADD; REAL_ADD_SYM; EQ_SYM; FLOOR_FRAC]) in
 let l4 = prove (`&0 <= frac (&10 pow p * x) / &10 pow p`, SIMP_TAC[REAL_LE_RDIV_EQ; l0; REAL_MUL_LZERO; FLOOR_FRAC]) in
   ASM_CASES_TAC `v = T` THEN FIRST_X_ASSUM MP_TAC THEN ASM_SIMP_TAC[evalf_rest_def] THEN 
   STRIP_TAC THEN FIRST_X_ASSUM (fun x -> ALL_TAC) THEN 
   CONV_TAC (GEN_REWRITE_CONV (PAT_CONV `\x. abs(x - y) < z`) [l2]) THEN 
   REWRITE_TAC[REAL_ARITH `a / b - c / b = (a - c) / b`] THENL 
   [
     GEN_REWRITE_TAC (PAT_CONV `\x. abs((x - y) / z) < v`) [REAL_ARITH `x = -- &1 / &2 + x + &1 / &2`]; 
     ALL_TAC
   ] THEN 
   REWRITE_TAC [REAL_ARITH `(a + b + c) - d = a + ((b + c) - d)`; SYM l3; real_abs; l4] THENL 
   [
     ALL_TAC; 
     SIMP_TAC [REAL_LT_DIV2_EQ; REAL_POW_LT; REAL_ARITH `&0 < &10`; FLOOR_FRAC]
   ] THEN
   ASM_CASES_TAC `&0 <= (-- &1 / &2 + frac (&10 pow p * x + &1 / &2)) / &10 pow p` THEN ASM_SIMP_TAC[] THEN 
   FIRST_X_ASSUM(fun x -> ALL_TAC) THEN 
   SIMP_TAC [REAL_ARITH `-- (a / b) = (-- a / b)`; REAL_LT_DIV2_EQ; REAL_POW_LT; REAL_ARITH `&0 < &10`] THENL 
   [
     REWRITE_TAC[MP (REAL_ARITH `frac x < &1 ==> -- &1 / &2 + frac x < &1`) (List.nth (CONJUNCTS (SPEC_ALL FLOOR_FRAC)) 2)];
     REWRITE_TAC[MP (REAL_ARITH `&0 <= frac x ==> --(-- &1 / &2 + frac x) < &1`) (List.nth (CONJUNCTS (SPEC_ALL FLOOR_FRAC)) 1)]
   ]
);;

let floor_compute = prove (`!n x. &n <= x /\ &n + &1 > x ==> floor x = &n`,
  REWRITE_TAC[GSYM FLOOR_UNIQUE; integer] THEN REPEAT STRIP_TAC THEN 
  ASM_SIMP_TAC[GSYM real_gt; real_abs; REAL_OF_NUM_LE; ARITH_RULE `0 <= n`] 
  THEN EXISTS_TAC `n:num` THEN SIMP_TAC [])
;;

(* TODO Calculates too many times same things... *)
let evalf_conv term =
  let term, r = dest_binop `N` term in
  let thm = REALCALC_BASE_CONV term (Int 10) (dest_numeral r) in
  let l, _ = dest_binop `(<)` (concl thm) in
  let no_abs = rand l in
  let approx, floor_t = dest_binop `(-)` no_abs in
  let num = dest_numeral (rand approx) in
  let rec find_thm num =
    let thm = GEN_REWRITE_RULE RAND_CONV [GSYM real_ge] (
      ((RAND_CONV o LAND_CONV) REAL_RAT_REDUCE_CONV) 
      (mk_binop `real_le` (mk_comb (`real_of_num`, (mk_numeral num))) floor_t)
    ) in
    let t1 = REWRITE_RULE [GSYM thm] (REALCALC_REL_CONV (get_res thm)) in
    let thm = GEN_REWRITE_RULE RAND_CONV [real_gt] (
      ((RAND_CONV o LAND_CONV) REAL_RAT_REDUCE_CONV) 
      (mk_binop `real_gt` (mk_binop `(+)` (mk_comb (`real_of_num`, (mk_numeral num))) `&1`) floor_t)
    ) in
    let t2 = REWRITE_RULE [GSYM thm] (REALCALC_REL_CONV (get_res thm)) in
    if (fst (dest_comb (concl t1))) = `(~)` then find_thm (num -/ (Int 1)) else
    if (fst (dest_comb (concl t2))) = `(~)` then find_thm (num +/ (Int 1)) else
    CONJ t1 t2
  in
  let bounds_thm = find_thm num in
  let floor_thm = MATCH_MP floor_compute bounds_thm in
  (*REWRITE_RULE [floor_thm; lemma]*)
  TRANS
    (SPECL [term; r] evalf_def)
    (REWRITE_RULE [floor_thm; REAL_ARITH `x = y - z <=> y = z + x`] 
      (SPECL[term; r] (GEN_ALL (CONJUNCT1 evalf_rest_def))))
;;

let evalf_conv term =
  let thm = REWRITE_CONV [DECIMAL] term in
  let rt = get_res thm in
  let thm2 = REAL_RAT_REDUCE_CONV rt in
  let rt2 = get_res thm2 in
  let thm3 = TRANS thm (TRANS thm2 (evalf_conv rt2)) in
  let rt3 = get_res thm3 in
  let thm4 = TRANS thm3 (LAND_CONV (RAND_CONV (REAL_RAT_POW_CONV)) rt3) in
  let rt4 = get_res thm4 in
  TRANS thm4 (my_depth_conv decimal_conv rt4)
;;
