let UNSTRIP_TAC = REPEAT (FIRST_ASSUM (fun t -> UNDISCH_TAC ((snd o dest_thm) t)));;
let UNCOMPLEX = REWRITE_TAC
  [complex_div; COMPLEX_MUL_RZERO; COMPLEX_MUL_LZERO; COMPLEX_ADD_LID; COMPLEX_ADD_RID;
   COMPLEX_MUL_RID; COMPLEX_MUL_LID; COMPLEX_ADD_LDISTRIB] THEN
  REWRITE_TAC [GSYM complex_div]
;;

let UNREAL = REWRITE_TAC
  [real_div; REAL_MUL_RZERO; REAL_MUL_LZERO; REAL_ADD_LID; REAL_ADD_RID;
    REAL_MUL_RID; REAL_MUL_LID; REAL_ADD_LDISTRIB]
  THEN REWRITE_TAC [GSYM real_div]
;;

let CLEAN_PREMISES1 =
  let cleaner asms =
    REPEAT (FIRST_X_ASSUM (fun _ -> ALL_TAC)) THEN
    let fold_fun (asms, delasms) thm =
      try
        let l, r = (dest_eq o snd o dest_thm) thm in
        ignore(dest_var l); (List.map (REWRITE_RULE [thm])
        (List.filter (fun t -> t <> thm) asms), thm::delasms)
      with _ -> (asms, delasms)
    in
    let asms, delasms = List.fold_left fold_fun (asms, []) asms in
(*    let asms = List.map (CONV_RULE (RAND_CONV COMPLEX_POLY_CONV)) asms in*)
    REWRITE_TAC delasms THEN MAP_EVERY ASSUME_TAC (List.rev asms)
  in
  REPEAT DISCH_TAC THEN ASSUM_LIST cleaner THEN UNSTRIP_TAC
;;

let CLEAN_PREMISES maxv rem =
  let cleaner asms =
    REPEAT (FIRST_X_ASSUM (fun _ -> ALL_TAC)) THEN
    let fold_fun (asms, delasms) thm =
      try 
        let t2 = ONCE_REWRITE_RULE [GSYM REAL_SUB_0] thm in
        let t3 = CONV_RULE (LAND_CONV REAL_POLY_CONV) t2 in
        if (List.length (frees (snd (dest_thm t3))) > maxv) then raise Exit else ();
        let t4 = REWRITE_RULE [REAL_LNEG_UNIQ; REAL_NEG_NEG] t3 in
        let l, r = (dest_eq o concl) t4 in
        let t5 = try
          let m, v = dest_binop `real_mul` l in
          let t5b = mk_eq (v, (mk_binop `(/)` r m)) in
          EQ_MP (REAL_ARITH (mk_eq ((concl t4),t5b))) t4
        with _ -> t4 in
        let t6 = CONV_RULE (RAND_CONV REAL_POLY_CONV) t5 in
        let l, r = (dest_eq o concl) t6 in
        ignore(dest_var l); 
        let rest = List.filter (fun t -> t <> thm) asms in
        if rem then
          (List.map (REWRITE_RULE [t6]) rest, thm::delasms)
        else
          (List.map (fun t -> if t <> thm then REWRITE_RULE [t6] t else t6) asms, thm::delasms)
      with _ -> 
        (asms, delasms)
    in
    let nasms, delasms = List.fold_left fold_fun (asms, []) asms in
    let nasms = try List.map (CONV_RULE (LAND_CONV REAL_RAT_REDUCE_CONV)) nasms with _ -> nasms in
    if nasms = asms then failwith "asms not changed" else
    REWRITE_TAC delasms THEN MAP_EVERY ASSUME_TAC (List.rev nasms)
  in
  REPEAT DISCH_TAC THEN ASSUM_LIST cleaner
;;
