let VECTOR_ARITH_CONV trm =
  let t1 = SIMP_CONV [CART_EQ; VECTOR_ADD_COMPONENT; VECTOR_SUB_COMPONENT;
    VECTOR_NEG_COMPONENT; VECTOR_MUL_COMPONENT; DIMINDEX_1; DIMINDEX_2; DIMINDEX_3;
    ARITH; vector; vec; LENGTH; LAMBDA_BETA; GSYM LT_SUC_LE] trm in
  let to_convert = rhs (concl t1) in
  let exc, lmb = dest_comb to_convert in
  let var, sub = dest_abs lmb in
  let lhs, rhs = dest_comb sub in
  let arr, assu = dest_comb lhs in
  let _, cond = dest_binop `(/\)` assu in
  let thm = EXPAND_CASES_CONV (mk_comb (exc, mk_abs (var, mk_comb (mk_comb (arr, cond), rhs)))) in
  let thm' = REWRITE_RULE [ARITH; EL; TL; HD] thm in
  let thm'' = REWRITE_RULE [num_CONV `1`; num_CONV `2`; EL; TL; HD] thm' in
  let t2 = REWRITE_RULE [ARITH] thm'' in
  prove(trm, SIMP_TAC[t1; t2])
;;

let cas_vector_thms = [
  VECTOR_ARITH_CONV `(vector [x]:real^1) + vec v = vector [x + &v]`; (* Addition *)
  VECTOR_ARITH_CONV `(vector [x; y]:real^2) + vec v = vector [x + &v; y + &v]`;
  VECTOR_ARITH_CONV `(vector [x; y; z]:real^3) + vec v = vector [x + &v; y + &v; z + &v]`;
  VECTOR_ARITH_CONV `(vector [x]:real^1) + vector [x'] = vector [x + x']`;
  VECTOR_ARITH_CONV `(vector [x; y]:real^2) + vector [x'; y'] = vector [x + x'; y + y']`;
  VECTOR_ARITH_CONV `(vector [x; y; z]:real^3) + vector [x'; y'; z'] = vector [x + x'; y + y'; z + z']`;
  prove(`vec v + vector l = vector l + vec v`, REWRITE_TAC[VECTOR_ADD_AC]);
  VECTOR_ARITH_CONV `v % (vector [x]:real^1) = vector [v * x]`; (* Multiplication *)
  VECTOR_ARITH_CONV `v % (vector [x; y]:real^2) = vector [v * x; v * y]`;
  VECTOR_ARITH_CONV `v % (vector [x; y; z]:real^3) = vector [v * x; v * y; v * z]`;
  VECTOR_SUB; (* Substraction *)
  VECTOR_NEG_MINUS1; (* Negation *)
(*VECTOR_ARITH_CONV `--(vector [x]:real^1) = vector [--x]`;
  VECTOR_ARITH_CONV `--(vector [x; y]:real^2) = vector [--x; --y]`;
  VECTOR_ARITH_CONV `--(vector [x; y; z]:real^3) = vector [--x; --y; --z]`;*)
  VECTOR_MUL_LZERO; VECTOR_MUL_LID; VECTOR_ADD_LID; VECTOR_ADD_RID; VECTOR_SUB_REFL;
  VECTOR_ADD_LINV; VECTOR_ADD_RINV; VECTOR_SUB_RADD; VECTOR_NEG_SUB;
  VECTOR_SUB_EQ; VECTOR_NEG_NEG  
];;

reduce_interface ("%", `vector_mul:real->real^N->real^N`);;

(* For the moment I avoid Lists since the following is not true: *)
(* g `vector l1 + vector l2 = vector (MAP2 (\x y. x + y) l1 l2)`
   (SPEC_TAC (`l1:real list`,`l1:real list`) THEN 
    SPEC_TAC (`l2:real list`,`l2:real list`) THEN 
    LIST_INDUCT_TAC THEN LIST_INDUCT_TAC THEN 
    ASM_SIMP_TAC[LENGTH; ARITH; EL; HD; ADD1; MAP2; EQT_ELIM(ARITH_CONV `~(i + 1 <= 0)`); ADD_SUB; REAL_ADD_LID; MAP2_DEF])
   Not true since MAP2 cuts the tails, whereas vector adition doesn't...
*)
